#!/bin/bash
set -e
#Caine plugin for multicd.sh
#version 5.7
#Copyright (c) 2010 maybeway36
#
#Permission is hereby granted, free of charge, to any person obtaining a copy
#of this software and associated documentation files (the "Software"), to deal
#in the Software without restriction, including without limitation the rights
#to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#copies of the Software, and to permit persons to whom the Software is
#furnished to do so, subject to the following conditions:
#
#The above copyright notice and this permission notice shall be included in
#all copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#THE SOFTWARE.
if [ $1 = scan ];then
	if [ -f caine.iso ];then
		echo "Caine"
	fi
elif [ $1 = copy ];then
	if [ -f caine.iso ];then
		echo "Copying Caine..."
		if [ ! -d caine ];then
			mkdir caine
		fi
		if grep -q "`pwd`/caine" /etc/mtab ; then
			umount caine
		fi
		mount -o loop caine.iso caine/
		cp -R caine/casper multicd-working/boot/caine #Live system
		cp caine/README.diskdefines multicd-working/
		mkdir multicd-working/CaineFiles
		cp -R caine/{AutoPlay,autorun.exe,autorun.inf,comdlg32.ocx,files,license.txt,page5,preseed,Programs,RegOcx4Vista.bat,rw_common,tabctl32.ocx,vbrun60.exe,WinTaylor.exe} multicd-working/CaineFiles
		umount caine;rmdir caine
		echo -n "Making initrd(s)..."
		if [ -d caine-inittmp ];then rm -r caine-inittmp;fi
		mkdir caine-inittmp
		cd caine-inittmp
		gzip -cd ../multicd-working/boot/caine/initrd.gz | cpio -id
		perl -pi -e 's/path\/casper/path\/boot\/caine/g' scripts/casper
		perl -pi -e 's/directory\/casper/directory\/boot\/caine/g' scripts/casper
		find . | cpio --create --format='newc' | gzip -c > ../multicd-working/boot/caine/initrd.gz
		cd ..
		rm -r caine-inittmp
		echo " done."
	fi
elif [ $1 = writecfg ];then
if [ -f caine.iso ];then
cat >> multicd-working/boot/isolinux/isolinux.cfg << EOF
label caine2
kernel /boot/caine/vmlinuz
initrd /boot/caine/initrd.gz
append live-media-path=/boot/caine ignore_uuid noprompt persistent BOOT_IMAGE=/casper/vmlinuz file=/cdrom/CaineFiles/custom.seed boot=casper -- debian-installer/language=en console-setup/layoutcode=en
EOF
fi
else
	echo "Usage: $0 {scan|copy|writecfg}"
	echo "Use only from within multicd.sh or a compatible script!"
	echo "Don't use this plugin script on its own!"
fi
